<html lang="zh-CN"><head><meta charset="utf-8"/><meta name="viewport" content="width=device-width, initial-scale=1"/><title>Deno.Command - Deno documentation - Deno 中文文档</title><link rel="icon" href="/favicon.ico"/><link rel="apple-touch-icon" href="/apple-touch-icon.png"/><link rel="preload" href="/fonts/inter/Inter-Regular.woff2" as="font" type="font/woff2" crossorigin="true"/><link rel="preload" href="/fonts/inter/Inter-SemiBold.woff2" as="font" type="font/woff2" crossorigin="true"/><link rel="me" href="https://fosstodon.org/@deno_land"/><meta name="twitter:title" content="Deno.Command - Deno documentation"/><meta name="twitter:description" content="深入的文档、指南和参考材料，用于构建安全、高性能的 JavaScript 和 TypeScript 应用程序，使用 Deno。"/><meta name="twitter:image" content="/img/og.webp"/><meta name="twitter:image:alt" content="深入的文档、指南和参考材料，用于构建安全、高性能的 JavaScript 和 TypeScript 应用程序，使用 Deno。"/><meta name="twitter:card" content="summary_large_image"/><meta name="twitter:site" content="@deno_land"/><meta property="og:title" content="Deno.Command - Deno documentation"/><meta property="og:description" content="深入的文档、指南和参考材料，用于构建安全、高性能的 JavaScript 和 TypeScript 应用程序，使用 Deno。"/><meta property="og:image" content="/img/og.webp"/><meta property="og:image:alt" content="深入的文档、指南和参考材料，用于构建安全、高性能的 JavaScript 和 TypeScript 应用程序，使用 Deno。"/><meta property="og:type" content="article"/><meta property="og:site_name" content="Deno"/><meta property="og:locale" content="en_US"/><meta name="keywords" content="Deno, JavaScript, TypeScript, reference, documentation, guide, tutorial, example"/><script>
            (function() {
              const theme = localStorage.getItem('denoDocsTheme') ||
                (window.matchMedia('(prefers-color-scheme: dark)').matches ? 'dark' : 'light');
              document.documentElement.classList.add(theme);
            })();
          </script><link rel="stylesheet" href="/gfm.css"/><link rel="stylesheet" href="/styles.css"/><link rel="stylesheet" href="/overrides.css"/><link rel="stylesheet" href="/style.css"/><link rel="stylesheet" href="/components.css"/><script type="module" defer src="/components.js"></script><script type="module" defer src="/lint_rules.client.js"></script><script type="module" defer src="/copy.client.js"></script><script type="module" defer src="/tabs.client.js"></script><script type="module" defer src="/feedback.client.js"></script><script async src="https://www.zhcndoc.com/js/common.js"></script><link rel="preconnect" href="https://www.googletagmanager.com"/></head><body><header><a href="/" title="Deno docs home" class="logo-link"><svg width="100%" height="100%" viewBox="0 0 1025 332" version="1.1" xmlns="http://www.w3.org/2000/svg" xml:space="preserve" style="fill-rule:evenodd;clip-rule:evenodd;stroke-linejoin:round;stroke-miterlimit:2;"><g id="background" transform="matrix(1,0,0,1,0.000105977,0.000105977)"><path d="M28.829,227.937C19.958,208.794 15.007,187.472 15.007,165.002C15.007,159.187 15.339,153.448 15.984,147.805C16.639,142.102 17.61,136.506 18.877,131.032C25.997,100.328 42.557,73.224 65.329,52.95C84.456,35.944 107.887,23.81 133.573,18.31C143.71,16.145 154.224,15.006 165.003,15.006C168.781,15.01 172.586,15.155 176.414,15.447C194.568,16.833 211.723,21.403 227.373,28.568C239.998,34.354 251.683,41.842 262.135,50.737C288.388,73.101 306.697,104.254 312.786,139.213C314.241,147.592 314.999,156.209 314.999,165.002C314.996,168.786 314.85,172.597 314.557,176.431C313.451,190.92 310.316,204.773 305.453,217.733C298.665,235.784 288.494,252.185 275.715,266.161C259.094,283.132 237.972,290.684 220.331,290.37C207.503,290.141 194.952,285.037 186.279,277.569C173.889,266.9 168.885,254.704 167.169,241.095C166.743,237.712 166.993,228.494 168.754,222.111C170.066,217.353 173.394,208.165 178.261,204.146C172.568,201.694 165.24,196.354 162.93,193.791C162.362,193.161 162.436,192.174 162.944,191.495C163.453,190.817 164.344,190.549 165.143,190.836C170.038,192.516 175.999,194.173 182.285,195.225C190.552,196.607 200.833,198.347 211.248,198.859C236.643,200.106 263.169,188.708 271.402,166.029C279.634,143.35 276.44,120.918 246.906,107.463C217.371,94.007 203.728,78.008 179.865,68.359C164.278,62.056 146.93,65.798 129.119,75.641C81.145,102.153 38.164,185.92 57.977,263.528C58.26,264.59 57.782,265.708 56.819,266.237C55.916,266.732 54.806,266.591 54.058,265.906C48.292,259.57 43.06,252.74 38.435,245.485C34.857,239.871 31.645,234.01 28.829,227.937Z" class="fill-black dark:fill-transparent"></path></g><g id="outline" transform="matrix(1,0,0,1,0.000105977,0.000105977)"><path d="M172.67,0.181C263.638,4.413 334.056,81.702 329.825,172.67C325.593,263.638 248.303,334.055 157.336,329.823C66.368,325.592 -4.05,248.303 0.181,157.336C4.413,66.368 81.702,-4.05 172.67,0.181ZM211.248,198.859C200.833,198.347 190.552,196.607 182.285,195.225C175.999,194.173 170.038,192.516 165.143,190.836C164.344,190.549 163.453,190.817 162.944,191.495C162.436,192.174 162.362,193.161 162.93,193.791C165.24,196.354 172.568,201.694 178.261,204.146C173.394,208.165 170.066,217.353 168.754,222.111C166.993,228.494 166.743,237.712 167.169,241.095C168.885,254.704 173.889,266.9 186.279,277.569C194.952,285.037 207.503,290.141 220.331,290.37C238.033,290.685 259.24,283.08 275.887,265.985C297.652,242.124 311.91,211.098 314.557,176.431C320.86,93.885 258.961,21.75 176.414,15.447C93.869,9.144 21.734,71.044 15.431,153.59C12.167,196.339 27.195,236.296 53.912,265.76C54.656,266.569 55.856,266.766 56.819,266.237C57.782,265.708 58.26,264.59 57.977,263.528C38.164,185.92 81.145,102.153 129.119,75.641C146.93,65.798 164.278,62.056 179.865,68.359C203.728,78.008 217.371,94.007 246.906,107.463C276.44,120.918 279.634,143.35 271.402,166.029C263.169,188.708 236.643,200.106 211.248,198.859Z" class="fill-transparent dark:fill-white"></path></g><g id="eye" transform="matrix(1,0,0,1,0.000105977,0.000105977)"><path d="M159.634,78.772C167.726,78.138 174.786,85.044 176.003,94.229C177.627,106.464 173.136,119.103 158.37,119.394C145.756,119.646 141.934,106.925 142.77,99.219C143.6,91.513 149.952,79.532 159.634,78.772Z" class="fill-black"></path></g><g transform="matrix(12.6005,0,0,12.6005,-6934.5,-3216.05)"><path d="M600.234,274.47C596.514,274.47 594.018,271.926 594.018,268.422C594.018,264.918 596.514,262.374 600.234,262.374C603.882,262.374 606.474,264.822 606.474,268.422C606.474,272.022 603.882,274.47 600.234,274.47ZM600.234,271.662C601.938,271.662 603.282,270.318 603.282,268.422C603.282,266.502 601.986,265.182 600.234,265.182C598.41,265.182 597.186,266.574 597.186,268.422C597.186,270.246 598.458,271.662 600.234,271.662ZM613.662,274.47C610.182,274.47 607.638,272.022 607.638,268.422C607.638,264.822 610.182,262.374 613.806,262.374C615.678,262.374 617.598,263.118 618.774,264.606L616.662,266.43C616.038,265.71 615.126,265.182 613.926,265.182C612.054,265.182 610.806,266.502 610.806,268.398C610.806,270.318 612.102,271.662 613.95,271.662C615.198,271.662 616.134,271.086 616.686,270.462L618.822,272.358C617.814,273.534 616.014,274.47 613.662,274.47ZM624.615,274.47C622.743,274.47 621.159,273.87 619.863,272.766L621.399,270.582C622.359,271.494 623.367,271.95 624.639,271.95C625.551,271.95 626.079,271.566 626.079,270.99C626.079,270.438 625.479,270.174 623.943,269.694C622.023,269.046 620.343,268.134 620.343,265.878C620.343,263.766 622.167,262.374 624.567,262.374C626.199,262.374 627.519,262.806 628.839,263.838L627.327,266.142C626.415,265.278 625.383,264.894 624.519,264.894C624.015,264.894 623.367,265.158 623.367,265.782C623.367,266.262 623.991,266.598 625.143,267.03C627.687,267.966 629.175,268.518 629.175,270.822C629.175,272.91 627.687,274.47 624.615,274.47ZM582.487,274.278L582.487,262.374L586.791,262.374C590.556,262.374 592.977,264.822 592.977,268.342C592.977,271.847 590.708,274.278 586.841,274.278L582.487,274.278ZM585.58,271.444L586.623,271.444C588.438,271.444 589.632,270.053 589.632,268.342C589.632,266.565 588.421,265.207 586.858,265.207L585.58,265.207L585.58,271.444Z" class="fill-black dark:fill-white"></path></g></svg></a><nav><a href="/runtime/" class="header-nav-link blocklink undefined">手册</a><a href="/api/deno/" class="header-nav-link blocklink undefined" data-active="true">API 参考</a><a href="/examples/" class="header-nav-link blocklink undefined">示例</a><a href="/deploy/manual/" class="header-nav-link blocklink services">服务</a></nav><a href="https://www.zhcndoc.com" class="external blocklink" target="_blank">简中文档</a><form action="https://www.google.com/search" method="get" class="search" target="_blank"><input type="search" name="q" id="search-str" placeholder="Search" class="search-input"/><input type="hidden" name="q" id="q" value="site:deno.com"/></form><button type="button" aria-label="toggle theme" class="theme-toggle" id="theme-toggle">Toggle Theme</button></header><nav class="refheader"><ul class="flex"><li><a class="blocklink refheader-link" data-active="true" href="/api/deno">Deno APIs</a></li><li><a class=" mx-1 px-2 text-md hover:bg-background-secondary ring-1 ring-transparent hover:ring-background-tertiary hover:rounded transition-colors duration-200 ease-in-out text-nowrap flex items-center [letter-spacing:0.2px] " href="/api/web">Web APIs</a></li><li><a class=" mx-1 px-2 text-md hover:bg-background-secondary ring-1 ring-transparent hover:ring-background-tertiary hover:rounded transition-colors duration-200 ease-in-out text-nowrap flex items-center [letter-spacing:0.2px] " href="/api/node">Node APIs</a></li></ul></nav><div class="layout"><label for="hamburger" class="hamburger-label"><span class="hamburger-bar hamburger-bar--top"></span><span class="hamburger-bar hamburger-bar--middle"></span><span class="hamburger-bar hamburger-bar--bottom"></span></label><input type="checkbox" id="hamburger" class="hamburger-checkbox"/><div class="nav" data-section="api" id="nav"><nav aria-labelledby="primary-navigation"><ul class="main-nav"><li><a href="/runtime/" class="main-nav-link">手册</a></li><li><a href="/api/deno/" class="main-nav-link" data-active="true">API 参考</a></li><li><a href="/examples/" class="main-nav-link">示例</a></li><li><a href="/deploy/manual/" class="main-nav-link">服务</a></li></ul></nav><nav aria-labelledby="section-navigation"><ul class="sub-nav"><li><a href=".././cloud" class="sub-nav-link blocklink">Cloud</a></li><li><a href=".././errors" class="sub-nav-link blocklink">Errors</a></li><li><a href=".././ffi" class="sub-nav-link blocklink">FFI</a></li><li><a href=".././fetch" class="sub-nav-link blocklink">Fetch</a></li><li><a href=".././file-system" class="sub-nav-link blocklink">File System</a></li><li><a href=".././gpu" class="sub-nav-link blocklink">GPU</a></li><li><a href=".././http-server" class="sub-nav-link blocklink">HTTP Server</a></li><li><a href=".././io" class="sub-nav-link blocklink">I/O</a></li><li><a href=".././jupyter" class="sub-nav-link blocklink">Jupyter</a></li><li><a href=".././linter" class="sub-nav-link blocklink">Linter</a></li><li><a href=".././network" class="sub-nav-link blocklink">Network</a></li><li><a href=".././permissions" class="sub-nav-link blocklink">Permissions</a></li><li><a href=".././runtime" class="sub-nav-link blocklink">Runtime</a></li><li><a href=".././subprocess" class="sub-nav-link blocklink">Subprocess</a></li><li><a href=".././telemetry" class="sub-nav-link blocklink">Telemetry</a></li><li><a href=".././testing" class="sub-nav-link blocklink">Testing</a></li><li><a href=".././websockets" class="sub-nav-link blocklink">WebSockets</a></li><li></li><li><a href=".././all_symbols" class="sub-nav-link blocklink">View all 500 symbols</a></li></ul></nav></div><div id="content" class="content"><div class="px-4 sm:px-5 md:px-6 w-full mx-auto 2xl:px-0 max-w-[40rem]"><article class="mx-auto"><div data-color-mode="auto" data-light-theme="light" data-dark-theme="dark" class="markdown-body mt-4 rounded-lg"><div class="ddoc markdown-body"><link rel="stylesheet" href="/reference_styles.css"/><ul class="breadcrumbs refcrumbs"><li><a href="../" class="contextLink">Deno</a></li><span class="text-[#0F172A]"><svg width="16" height="16" viewBox="0 0 16 16" fill="none" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" clip-rule="evenodd" d="M5.76748 11.8159C5.5378 11.577 5.54525 11.1972 5.78411 10.9675L8.93431 8L5.78411 5.0325C5.54525 4.80282 5.5378 4.423 5.76748 4.18413C5.99715 3.94527 6.37698 3.93782 6.61584 4.1675L10.2158 7.5675C10.3335 7.68062 10.4 7.83679 10.4 8C10.4 8.16321 10.3335 8.31938 10.2158 8.4325L6.61584 11.8325C6.37698 12.0622 5.99715 12.0547 5.76748 11.8159Z" fill="currentColor"></path></svg></span><span><li><a href="../././~/Deno" class="contextLink">Deno</a></li><span>.</span><li>Command</li></span></ul><div id="content"><main class="symbolGroup" id="symbol_Deno.Command"><article><h1 class="ref-h1"><span class="text-Class">class</span> <span class="font-bold">Deno.Command</span></h1><div class="symbolSubtitle"></div><div class="space-x-2 !mt-2"><div class="text-permissions border border-permissions/50 bg-permissions/5 inline-flex items-center gap-0.5 flex-none rounded-md leading-none font-bold py-2 px-3"><span class="space-x-2"><span>allow-run</span></span></div></div><div><div class="space-y-7" id><div><div data-color-mode="dark" data-light-theme="light" data-dark-theme="dark" class="markdown-body"><p>Create a child process.</p>
<p>If any stdio options are not set to <code>&quot;piped&quot;</code>, accessing the corresponding
field on the <code>Command</code> or its <code>CommandOutput</code> will throw a <code>TypeError</code>.</p>
<p>If <code>stdin</code> is set to <code>&quot;piped&quot;</code>, the <code>stdin</code> <code>WritableStream</code>
needs to be closed manually.</p>
<p><code>Command</code> acts as a builder. Each call to <code>Command.spawn</code> or
<code>Command.output</code> will spawn a new subprocess.</p>
</div></div><section class="section" id="examples"><h3 class="anchorable-heading">Examples <a href="#examples" class="anchor-link" aria-label="Anchor" tabindex="-1">#</a></h3><div class="space-y-8"><div class="anchorable"><a href="#example_0" class="anchor-link" aria-label="Anchor" tabindex="-1">#</a><div><div data-color-mode="dark" data-light-theme="light" data-dark-theme="dark" class="markdown-body"><div class="relative"><pre><code class="highlight notranslate language-ts"><span class="token keyword">const</span> command <span class="token operator">=</span> <span class="token keyword">new</span> <span class="token class-name">Deno</span><span class="token punctuation">.</span><span class="token function">Command</span><span class="token punctuation">(</span>Deno<span class="token punctuation">.</span><span class="token function">execPath</span><span class="token punctuation">(</span><span class="token punctuation">)</span><span class="token punctuation">,</span> <span class="token punctuation">{</span>
  args<span class="token operator">:</span> <span class="token punctuation">[</span>
    <span class="token string">"eval"</span><span class="token punctuation">,</span>
    <span class="token string">"console.log('Hello World')"</span><span class="token punctuation">,</span>
  <span class="token punctuation">]</span><span class="token punctuation">,</span>
  stdin<span class="token operator">:</span> <span class="token string">"piped"</span><span class="token punctuation">,</span>
  stdout<span class="token operator">:</span> <span class="token string">"piped"</span><span class="token punctuation">,</span>
<span class="token punctuation">}</span><span class="token punctuation">)</span><span class="token punctuation">;</span>
<span class="token keyword">const</span> child <span class="token operator">=</span> command<span class="token punctuation">.</span><span class="token function">spawn</span><span class="token punctuation">(</span><span class="token punctuation">)</span><span class="token punctuation">;</span>

<span class="token comment">// open a file and pipe the subprocess output to it.</span>
child<span class="token punctuation">.</span>stdout<span class="token punctuation">.</span><span class="token function">pipeTo</span><span class="token punctuation">(</span>
  Deno<span class="token punctuation">.</span><span class="token function">openSync</span><span class="token punctuation">(</span><span class="token string">"output"</span><span class="token punctuation">,</span> <span class="token punctuation">{</span> write<span class="token operator">:</span> <span class="token boolean">true</span><span class="token punctuation">,</span> create<span class="token operator">:</span> <span class="token boolean">true</span> <span class="token punctuation">}</span><span class="token punctuation">)</span><span class="token punctuation">.</span>writable<span class="token punctuation">,</span>
<span class="token punctuation">)</span><span class="token punctuation">;</span>

<span class="token comment">// manually close stdin</span>
child<span class="token punctuation">.</span>stdin<span class="token punctuation">.</span><span class="token function">close</span><span class="token punctuation">(</span><span class="token punctuation">)</span><span class="token punctuation">;</span>
<span class="token keyword">const</span> status <span class="token operator">=</span> <span class="token keyword">await</span> child<span class="token punctuation">.</span>status<span class="token punctuation">;</span>
</code></pre>

      <button id="copy-button-0" class="copyButton" data-copy="const command = new Deno.Command(Deno.execPath(), {
  args: [
    &quot;eval&quot;,
    &quot;console.log(&apos;Hello World&apos;)&quot;,
  ],
  stdin: &quot;piped&quot;,
  stdout: &quot;piped&quot;,
});
const child = command.spawn();

// open a file and pipe the subprocess output to it.
child.stdout.pipeTo(
  Deno.openSync(&quot;output&quot;, { write: true, create: true }).writable,
);

// manually close stdin
child.stdin.close();
const status = await child.status;
" title="Copy">
        <svg class="copy-icon" width="15" height="15" viewBox="0 0 15 15" fill="none" xmlns="http://www.w3.org/2000/svg">
          <rect x="2" y="2" width="7" height="7" fill="none"/>
          <rect x="6" y="6" width="7" height="7" fill="none"/>
          <path d="M1.55566 2.7C1.55566 2.03726 2.09292 1.5 2.75566 1.5H8.75566C9.41841 1.5 9.95566 2.03726 9.95566 2.7V5.1H12.3557C13.0184 5.1 13.5557 5.63726 13.5557 6.3V12.3C13.5557 12.9627 13.0184 13.5 12.3557 13.5H6.35566C5.69292 13.5 5.15566 12.9627 5.15566 12.3V9.9H2.75566C2.09292 9.9 1.55566 9.36274 1.55566 8.7V2.7ZM6.35566 9.9V12.3H12.3557V6.3H9.95566V8.7C9.95566 9.36274 9.41841 9.9 8.75566 9.9H6.35566ZM8.75566 8.7V2.7H2.75566V8.7H8.75566Z" fill="hsla(var(--foreground-secondary))"/>
        </svg>
        <svg class="check-icon hidden" width="15" height="15" viewBox="0 0 15 15" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M3 7.5L6.5 11L12 3" stroke="green" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"/>
        </svg>
      </button>
    </div></div></div></div><div class="border-b border-gray-300"></div><div class="anchorable"><a href="#example_1" class="anchor-link" aria-label="Anchor" tabindex="-1">#</a><div><div data-color-mode="dark" data-light-theme="light" data-dark-theme="dark" class="markdown-body"><div class="relative"><pre><code class="highlight notranslate language-ts"><span class="token keyword">const</span> command <span class="token operator">=</span> <span class="token keyword">new</span> <span class="token class-name">Deno</span><span class="token punctuation">.</span><span class="token function">Command</span><span class="token punctuation">(</span>Deno<span class="token punctuation">.</span><span class="token function">execPath</span><span class="token punctuation">(</span><span class="token punctuation">)</span><span class="token punctuation">,</span> <span class="token punctuation">{</span>
  args<span class="token operator">:</span> <span class="token punctuation">[</span>
    <span class="token string">"eval"</span><span class="token punctuation">,</span>
    <span class="token string">"console.log('hello'); console.error('world')"</span><span class="token punctuation">,</span>
  <span class="token punctuation">]</span><span class="token punctuation">,</span>
<span class="token punctuation">}</span><span class="token punctuation">)</span><span class="token punctuation">;</span>
<span class="token keyword">const</span> <span class="token punctuation">{</span> code<span class="token punctuation">,</span> stdout<span class="token punctuation">,</span> stderr <span class="token punctuation">}</span> <span class="token operator">=</span> <span class="token keyword">await</span> command<span class="token punctuation">.</span><span class="token function">output</span><span class="token punctuation">(</span><span class="token punctuation">)</span><span class="token punctuation">;</span>
<span class="token builtin">console</span><span class="token punctuation">.</span><span class="token function">assert</span><span class="token punctuation">(</span>code <span class="token operator">===</span> <span class="token number">0</span><span class="token punctuation">)</span><span class="token punctuation">;</span>
<span class="token builtin">console</span><span class="token punctuation">.</span><span class="token function">assert</span><span class="token punctuation">(</span><span class="token string">"hello\n"</span> <span class="token operator">===</span> <span class="token keyword">new</span> <span class="token class-name">TextDecoder</span><span class="token punctuation">(</span><span class="token punctuation">)</span><span class="token punctuation">.</span><span class="token function">decode</span><span class="token punctuation">(</span>stdout<span class="token punctuation">)</span><span class="token punctuation">)</span><span class="token punctuation">;</span>
<span class="token builtin">console</span><span class="token punctuation">.</span><span class="token function">assert</span><span class="token punctuation">(</span><span class="token string">"world\n"</span> <span class="token operator">===</span> <span class="token keyword">new</span> <span class="token class-name">TextDecoder</span><span class="token punctuation">(</span><span class="token punctuation">)</span><span class="token punctuation">.</span><span class="token function">decode</span><span class="token punctuation">(</span>stderr<span class="token punctuation">)</span><span class="token punctuation">)</span><span class="token punctuation">;</span>
</code></pre>

      <button id="copy-button-0" class="copyButton" data-copy="const command = new Deno.Command(Deno.execPath(), {
  args: [
    &quot;eval&quot;,
    &quot;console.log(&apos;hello&apos;); console.error(&apos;world&apos;)&quot;,
  ],
});
const { code, stdout, stderr } = await command.output();
console.assert(code === 0);
console.assert(&quot;hello\n&quot; === new TextDecoder().decode(stdout));
console.assert(&quot;world\n&quot; === new TextDecoder().decode(stderr));
" title="Copy">
        <svg class="copy-icon" width="15" height="15" viewBox="0 0 15 15" fill="none" xmlns="http://www.w3.org/2000/svg">
          <rect x="2" y="2" width="7" height="7" fill="none"/>
          <rect x="6" y="6" width="7" height="7" fill="none"/>
          <path d="M1.55566 2.7C1.55566 2.03726 2.09292 1.5 2.75566 1.5H8.75566C9.41841 1.5 9.95566 2.03726 9.95566 2.7V5.1H12.3557C13.0184 5.1 13.5557 5.63726 13.5557 6.3V12.3C13.5557 12.9627 13.0184 13.5 12.3557 13.5H6.35566C5.69292 13.5 5.15566 12.9627 5.15566 12.3V9.9H2.75566C2.09292 9.9 1.55566 9.36274 1.55566 8.7V2.7ZM6.35566 9.9V12.3H12.3557V6.3H9.95566V8.7C9.95566 9.36274 9.41841 9.9 8.75566 9.9H6.35566ZM8.75566 8.7V2.7H2.75566V8.7H8.75566Z" fill="hsla(var(--foreground-secondary))"/>
        </svg>
        <svg class="check-icon hidden" width="15" height="15" viewBox="0 0 15 15" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M3 7.5L6.5 11L12 3" stroke="green" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"/>
        </svg>
      </button>
    </div></div></div></div><div class="border-b border-gray-300"></div><div class="anchorable"><a href="#example_2" class="anchor-link" aria-label="Anchor" tabindex="-1">#</a><div><div data-color-mode="dark" data-light-theme="light" data-dark-theme="dark" class="markdown-body"><div class="relative"><pre><code class="highlight notranslate language-ts"><span class="token keyword">const</span> command <span class="token operator">=</span> <span class="token keyword">new</span> <span class="token class-name">Deno</span><span class="token punctuation">.</span><span class="token function">Command</span><span class="token punctuation">(</span>Deno<span class="token punctuation">.</span><span class="token function">execPath</span><span class="token punctuation">(</span><span class="token punctuation">)</span><span class="token punctuation">,</span> <span class="token punctuation">{</span>
  args<span class="token operator">:</span> <span class="token punctuation">[</span>
    <span class="token string">"eval"</span><span class="token punctuation">,</span>
    <span class="token string">"console.log('hello'); console.error('world')"</span><span class="token punctuation">,</span>
  <span class="token punctuation">]</span><span class="token punctuation">,</span>
<span class="token punctuation">}</span><span class="token punctuation">)</span><span class="token punctuation">;</span>
<span class="token keyword">const</span> <span class="token punctuation">{</span> code<span class="token punctuation">,</span> stdout<span class="token punctuation">,</span> stderr <span class="token punctuation">}</span> <span class="token operator">=</span> command<span class="token punctuation">.</span><span class="token function">outputSync</span><span class="token punctuation">(</span><span class="token punctuation">)</span><span class="token punctuation">;</span>
<span class="token builtin">console</span><span class="token punctuation">.</span><span class="token function">assert</span><span class="token punctuation">(</span>code <span class="token operator">===</span> <span class="token number">0</span><span class="token punctuation">)</span><span class="token punctuation">;</span>
<span class="token builtin">console</span><span class="token punctuation">.</span><span class="token function">assert</span><span class="token punctuation">(</span><span class="token string">"hello\n"</span> <span class="token operator">===</span> <span class="token keyword">new</span> <span class="token class-name">TextDecoder</span><span class="token punctuation">(</span><span class="token punctuation">)</span><span class="token punctuation">.</span><span class="token function">decode</span><span class="token punctuation">(</span>stdout<span class="token punctuation">)</span><span class="token punctuation">)</span><span class="token punctuation">;</span>
<span class="token builtin">console</span><span class="token punctuation">.</span><span class="token function">assert</span><span class="token punctuation">(</span><span class="token string">"world\n"</span> <span class="token operator">===</span> <span class="token keyword">new</span> <span class="token class-name">TextDecoder</span><span class="token punctuation">(</span><span class="token punctuation">)</span><span class="token punctuation">.</span><span class="token function">decode</span><span class="token punctuation">(</span>stderr<span class="token punctuation">)</span><span class="token punctuation">)</span><span class="token punctuation">;</span>
</code></pre>

      <button id="copy-button-0" class="copyButton" data-copy="const command = new Deno.Command(Deno.execPath(), {
  args: [
    &quot;eval&quot;,
    &quot;console.log(&apos;hello&apos;); console.error(&apos;world&apos;)&quot;,
  ],
});
const { code, stdout, stderr } = command.outputSync();
console.assert(code === 0);
console.assert(&quot;hello\n&quot; === new TextDecoder().decode(stdout));
console.assert(&quot;world\n&quot; === new TextDecoder().decode(stderr));
" title="Copy">
        <svg class="copy-icon" width="15" height="15" viewBox="0 0 15 15" fill="none" xmlns="http://www.w3.org/2000/svg">
          <rect x="2" y="2" width="7" height="7" fill="none"/>
          <rect x="6" y="6" width="7" height="7" fill="none"/>
          <path d="M1.55566 2.7C1.55566 2.03726 2.09292 1.5 2.75566 1.5H8.75566C9.41841 1.5 9.95566 2.03726 9.95566 2.7V5.1H12.3557C13.0184 5.1 13.5557 5.63726 13.5557 6.3V12.3C13.5557 12.9627 13.0184 13.5 12.3557 13.5H6.35566C5.69292 13.5 5.15566 12.9627 5.15566 12.3V9.9H2.75566C2.09292 9.9 1.55566 9.36274 1.55566 8.7V2.7ZM6.35566 9.9V12.3H12.3557V6.3H9.95566V8.7C9.95566 9.36274 9.41841 9.9 8.75566 9.9H6.35566ZM8.75566 8.7V2.7H2.75566V8.7H8.75566Z" fill="hsla(var(--foreground-secondary))"/>
        </svg>
        <svg class="check-icon hidden" width="15" height="15" viewBox="0 0 15 15" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M3 7.5L6.5 11L12 3" stroke="green" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"/>
        </svg>
      </button>
    </div></div></div></div></div></section><section class="section" id="constructors"><h3 class="anchorable-heading">Constructors <a href="#constructors" class="anchor-link" aria-label="Anchor" tabindex="-1">#</a></h3><div class="space-y-8"><div class="anchorable docEntry" id="constructor_0"><div class="docEntryHeader"><code class="inline-code-block"><a href="#constructor_0" class="anchor-link" aria-label="Anchor" tabindex="-1">#</a><span class="font-bold font-lg">Command</span><span class="font-medium">(<div class="ml-4"><div><span>command<span>: <span><span>string</span><span> | </span><span>URL</span></span></span></span>,</div><div><span>options?<span>: <a href="../././~/Deno.CommandOptions" class="link">CommandOptions</a></span></span>,</div></div>)</span></code> <span><div class="text-new border border-new/50 bg-new/5 inline-flex items-center gap-0.5 flex-none rounded-md leading-none text-sm py-1 px-2">new</div></span></div></div></div></section><section class="section" id="methods"><h3 class="anchorable-heading">Methods <a href="#methods" class="anchor-link" aria-label="Anchor" tabindex="-1">#</a></h3><div class="space-y-8"><div class="anchorable docEntry" id="method_output_0"><div class="docEntryHeader"><code class><a href="#method_output_0" class="anchor-link" aria-label="Anchor" tabindex="-1">#</a><a class="font-bold font-lg link" href="../././~/Deno.Command.prototype.output">output</a><span class="font-medium">()<span>: <span>Promise</span>&lt;<a href="../././~/Deno.CommandOutput" class="link">CommandOutput</a>&gt;</span></span></code> </div><div class="max-w-[75ch]"><div data-color-mode="dark" data-light-theme="light" data-dark-theme="dark" class="markdown-body"><p>Executes the <a href="../././~/Deno.Command"><code>Deno.Command</code></a>, waiting for it to finish and
collecting all of its output.</p>
<p>Will throw an error if <code>stdin: &quot;piped&quot;</code> is set.</p>
<p>If options <code>stdout</code> or <code>stderr</code> are not set to <code>&quot;piped&quot;</code>, accessing the
corresponding field on <a href="../././~/Deno.CommandOutput"><code>Deno.CommandOutput</code></a> will throw a <code>TypeError</code>.</p>
</div></div></div><div class="anchorable docEntry" id="method_outputsync_0"><div class="docEntryHeader"><code class><a href="#method_outputsync_0" class="anchor-link" aria-label="Anchor" tabindex="-1">#</a><a class="font-bold font-lg link" href="../././~/Deno.Command.prototype.outputSync">outputSync</a><span class="font-medium">()<span>: <a href="../././~/Deno.CommandOutput" class="link">CommandOutput</a></span></span></code> </div><div class="max-w-[75ch]"><div data-color-mode="dark" data-light-theme="light" data-dark-theme="dark" class="markdown-body"><p>Synchronously executes the <a href="../././~/Deno.Command"><code>Deno.Command</code></a>, waiting for it to
finish and collecting all of its output.</p>
<p>Will throw an error if <code>stdin: &quot;piped&quot;</code> is set.</p>
<p>If options <code>stdout</code> or <code>stderr</code> are not set to <code>&quot;piped&quot;</code>, accessing the
corresponding field on <a href="../././~/Deno.CommandOutput"><code>Deno.CommandOutput</code></a> will throw a <code>TypeError</code>.</p>
</div></div></div><div class="anchorable docEntry" id="method_spawn_0"><div class="docEntryHeader"><code class><a href="#method_spawn_0" class="anchor-link" aria-label="Anchor" tabindex="-1">#</a><a class="font-bold font-lg link" href="../././~/Deno.Command.prototype.spawn">spawn</a><span class="font-medium">()<span>: <a href="../././~/Deno.ChildProcess" class="link">ChildProcess</a></span></span></code> </div><div class="max-w-[75ch]"><div data-color-mode="dark" data-light-theme="light" data-dark-theme="dark" class="markdown-body"><p>Spawns a streamable subprocess, allowing to use the other methods.</p>
</div></div></div></div></section></div></div></article></main></div></div></div></article></div><nav class="documentNavigation toc-desktop"><ul><li><a href="#examples" title="Examples">Examples</a></li><li><ul><li><a href="#example_0" title="Spawn a subprocess and pipe the output to a file

">Spawn a subprocess and pipe the output to a file

</a></li><li><a href="#example_1" title="Spawn a subprocess and collect its output

">Spawn a subprocess and collect its output

</a></li><li><a href="#example_2" title="Spawn a subprocess and collect its output synchronously

">Spawn a subprocess and collect its output synchronously

</a></li></ul></li><li><a href="#constructors" title="Constructors">Constructors</a></li><li><ul><li><a href="#constructor_0" title="Command">Command</a></li></ul></li><li><a href="#methods" title="Methods">Methods</a></li><li><ul><li><a href="#method_output_0" title="output">output</a></li><li><a href="#method_outputsync_0" title="outputSync">outputSync</a></li><li><a href="#method_spawn_0" title="spawn">spawn</a></li></ul></li></ul></nav></div><footer><nav aria-labelledby="footer-navigation" class="footer-nav"><section class="footer-section"><h3 class="footer-section-heading">Deno 文档</h3><ul class="footer-list"><li><a class="footer-link" href="/runtime/">Deno 运行时</a></li><li><a class="footer-link" href="/deploy/manual/">Deno 部署</a></li><li><a class="footer-link" href="/subhosting/manual/">Deno 子托管</a></li><li><a class="footer-link" href="/examples/">示例</a></li><li><a class="footer-link" href="https://jsr.io/@std">标准库</a></li></ul></section><section class="footer-section"><h3 class="footer-section-heading">社区</h3><ul class="footer-list"><li><a class="footer-link" href="https://discord.gg/deno">Discord</a></li><li><a class="footer-link" href="https://github.com/denoland">GitHub</a></li><li><a class="footer-link" href="https://twitter.com/deno_land">Twitter</a></li><li><a class="footer-link" href="https://youtube.com/@deno_land">YouTube</a></li><li><a class="footer-link" href="https://deno.news/">新闻通讯</a></li></ul></section><section class="footer-section"><h3 class="footer-section-heading">帮助与反馈</h3><ul class="footer-list"><li><a class="footer-link" href="https://discord.gg/deno">社区支持</a></li><li><a class="footer-link" href="https://denostatus.com">部署系统状态</a></li><li><a class="footer-link" href="https://github.com/denoland/deploy_feedback">部署反馈</a></li><li><a class="footer-link" href="mailto:support@deno.com">报告问题</a></li></ul></section><section class="footer-section"><h3 class="footer-section-heading">公司</h3><ul class="footer-list"><li><a class="footer-link" href="https://deno.com/blog">博客</a></li><li><a class="footer-link" href="https://deno.com/jobs">招聘</a></li><li><a class="footer-link" href="https://merch.deno.com/">周边商品</a></li><li><a class="footer-link" href="/deploy/manual/privacy-policy">隐私政策</a></li></ul></section></nav><p class="copyright"><a target="_blank" href="https://www.zhcndoc.com">简中文档</a>｜<a rel="nofollow" target="_blank" href="https://beian.miit.gov.cn">沪ICP备2024070610号-3</a></p></footer></div></body></html>